MagicSquare Class Reference
Example scripts (models)

Example: Magic squares More...

## Public Types

enum | { BRANCH_SIZE , BRANCH_AFC_SIZE , BRANCH_CBS_MAX_SD }
| Branching to use for model. More...
enum | { BRANCH_SIZE , BRANCH_AFC_SIZE }
| Branching to use for model. More...

## Public Member Functions

| MagicSquare (const SizeOptions &opt)
| Post constraints.
| MagicSquare (MagicSquare &s)
| Constructor for cloning s.
virtual Space * | copy (void)
| Copy during cloning.
virtual void | print (std::ostream &os) const
| Print solution.
| MagicSquare (const SizeOptions &opt)
| Post constraints.
| MagicSquare (MagicSquare &s)
| Constructor for cloning s.
virtual Space * | copy (void)
| Copy during cloning.
virtual void | print (std::ostream &os) const
| Print solution.
Public Member Functions inherited from Gecode::Driver::ScriptBase< Driver::IgnoreStepOption< Space > >
| ScriptBase (const Options &opt)
| Constructor.
| ScriptBase (ScriptBase &e)
| Constructor used for cloning.
virtual void | compare (const Space &home, std::ostream &os) const
| Compare with s.
Public Member Functions inherited from Gecode::Driver::IgnoreStepOption< BaseSpace >
| IgnoreStepOption (const Options &)
| Constructor.
| IgnoreStepOption (BaseSpace &e)
| Constructor used for cloning.

## Related Symbols

(Note that these are not member symbols.)
int | main (int argc, char *argv[])
| Main-function.

## Additional Inherited Members

Static Public Member Functions inherited from Gecode::Driver::ScriptBase< Driver::IgnoreStepOption< Space > >
static std::ostream & | select_ostream (const char *sn, std::ofstream &ofs)
| Choose output stream according to sn.
static void | run (const Options &opt, Script *s=NULL)

## Detailed Description

Example: Magic squares

Compute magic squares of arbitrary size

See problem 19 at http://www.csplib.org/.

Definition at line 61 of file magic-square-partial.cpp.

## Member Enumeration Documentation

## anonymous enum

anonymous enum

Branching to use for model.

Enumerator
BRANCH_SIZE | Branch by size.
BRANCH_AFC_SIZE | Branch by size over AFC.
BRANCH_CBS_MAX_SD | Use maximum solution density.

Definition at line 74 of file magic-square-partial.cpp.

## anonymous enum

anonymous enum

Branching to use for model.

Enumerator
BRANCH_SIZE | Branch by size.
BRANCH_AFC_SIZE | Branch by size over AFC.

Definition at line 59 of file magic-square.cpp.

## Constructor & Destructor Documentation

## MagicSquare() [1/4]

MagicSquare::MagicSquare | ( | const SizeOptions & | opt | ) |

inline

Post constraints.

Definition at line 80 of file magic-square-partial.cpp.

## MagicSquare() [2/4]

MagicSquare::MagicSquare | ( | MagicSquare & | s | ) |

inline

Constructor for cloning s.

Definition at line 137 of file magic-square-partial.cpp.

## MagicSquare() [3/4]

MagicSquare::MagicSquare | ( | const SizeOptions & | opt | ) |

inline

Post constraints.

Definition at line 64 of file magic-square.cpp.

## MagicSquare() [4/4]

MagicSquare::MagicSquare | ( | MagicSquare & | s | ) |

inline

Constructor for cloning s.

Definition at line 109 of file magic-square.cpp.

## Member Function Documentation

## copy() [1/2]

virtual Space * MagicSquare::copy | ( | void |  | ) |

inline virtual

Copy during cloning.

Definition at line 144 of file magic-square-partial.cpp.

## print() [1/2]

virtual void MagicSquare::print | ( | std::ostream & | os | ) | const

inline virtual

Print solution.

Reimplemented from Gecode::Driver::ScriptBase< Driver::IgnoreStepOption< Space > >.

Definition at line 149 of file magic-square-partial.cpp.

## copy() [2/2]

virtual Space * MagicSquare::copy | ( | void |  | ) |

inline virtual

Copy during cloning.

Definition at line 115 of file magic-square.cpp.

## print() [2/2]

virtual void MagicSquare::print | ( | std::ostream & | os | ) | const

inline virtual

Print solution.

Reimplemented from Gecode::Driver::ScriptBase< Driver::IgnoreStepOption< Space > >.

Definition at line 120 of file magic-square.cpp.

## Friends And Related Symbol Documentation

## main()

int main | ( | int | argc,
|  | char * | argv[] )

related

Main-function.

Definition at line 168 of file magic-square-partial.cpp.

The documentation for this class was generated from the following files:

- examples/magic-square-partial.cpp
- examples/magic-square.cpp